# This file is a template, and might need editing before it works on your project.
# To contribute improvements to CI/CD templates, please follow the Development guide at:
# https://docs.gitlab.com/ee/development/cicd/templates.html
# This specific template is located at:
# https://gitlab.com/gitlab-org/gitlab/-/blob/master/lib/gitlab/ci/templates/Getting-Started.gitlab-ci.yml

# This is a sample GitLab CI/CD configuration file that should run without any modifications.
# It demonstrates a basic 3 stage CI/CD pipeline. Instead of real tests or scripts,
# it uses echo commands to simulate the pipeline execution.
#
# A pipeline is composed of independent jobs that run scripts, grouped into stages.
# Stages run in sequential order, but jobs within stages run in parallel.
#
# For more information, see: https://docs.gitlab.com/ee/ci/yaml/index.html#stages

stages:          # List of stages for jobs, and their order of execution
  - pre-commit
  - test
  - pop-release

include:
  - project: saltstack/pop/cicd/ci-templates
    file: /lint/pre-commit-run-all.yml
  - project: saltstack/pop/cicd/ci-templates
    file: /release/pop_release.yml

pre-commit-run-all:
  image: registry.gitlab.com/saltstack/pop/cicd/containers/alpinelint:py39

variables:
  CICD_UPSTREAM_PATH: "vmware/idem/tf-idem-auto"

.test-suite:
  stage: test
  needs:
    - pre-commit-run-all
  script:
    - python3 -m pip install nox coverage
    - nox -e tests-3 -- -vv tests
    - coverage report --data-file="artifacts/.coverage" --include="*/tf-idem-auto/tf_idem_auto/*" -m
    - coverage html --data-file="artifacts/.coverage" --include="*/tf-idem-auto/tf_idem_auto/*" --directory="artifacts"
  artifacts:
    when: always
    paths:
      - artifacts
    reports:
      junit: artifacts/junit-report.xml
    expire_in: 30 days

tests-3.7:
  extends: .test-suite
  image: python:3.7

tests-3.8:
  extends: .test-suite
  image: python:3.8

tests-3.9:
  extends: .test-suite
  image: python:3.9

tests-3.10:
  extends: .test-suite
  image: python:3.10.0
